/*##############################################################################

nIP - Testapplication

File        : telnet.h

Description : Simple Telnet Application to test TCP

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

##############################################################################*/

#ifndef _HTTPD_H
 #define _HTTPD_H

#include "globals.h"
#include "stdint.h"


#ifndef HTTPD_ENABLE
	#define HTTPD_ENABLE  1
#endif

#define HTTP_PARSER_COUNT 3

#define HTTP_ADDR_PARSER 1 /* until what index address are being parsed */
#define HTTP_NL_PARSER   2 /* index of newline parser */

typedef enum
{
	HTTP_STAT_ADDR,
	HTTP_STAT_GOTONL,
	HTTP_STAT_200,
	HTTP_STAT_501,
	HTTP_STAT_404,
	HTTP_STAT_CLOSE
}
http_state_t;

struct http_parser
{
	uint8_t pos;
	uint8_t sz;
	uint8_t *s;
};

void httpd_start( void );
void httpd_check( void );

#endif /* _TELNET_H */
