/*##############################################################################

nIP - nano IP stack

File        : ethernet.h

Description : Ethernet

Copyright notice:

Copyright (C) 2005 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

##############################################################################*/

#ifndef _NIP_ETHERNET_H
 #define _NIP_ETHERNET_H

#include "nip_init.h"
#include "net/net_if.h"

#define ETH_NIC_CHECK_MAC /**< if defined the physical address check will be left to the NIC */


struct ethernet_header_s{
	uint8_t EnetPacketDest[6]; /**< MAC Zieladresse 6 Byte */
	uint8_t EnetPacketSrc[6];  /**< MAC Quelladresse 6 Byte */
	uint8_t EnetPacketType[2]; /**< Nutzlast 0x0800=IP Datagramm;0x0806 = ARP */
};


void     nip_eth_configure_if_defaults( nip_net_if_id_t net_if_id );
//void     nip_eth_receive(nip_net_if_id_t net_if_id);
void nip_eth_disp_receive( void );

uint8_t  nip_eth_header (nip_net_if_id_t net_if_id, nip_net_trans_id_t trans_id,
         	uint16_t type, void *daddr, void *saddr, uint16_t len);

#endif /* _NIP_ETHERNET_H */
