/*##############################################################################

nIP - nano IP stack

File        : nip_bswap.c

Description : swap multi-byte integer byteorder

Copyright notice:

Copyright (C) 2007 -
Andreas Dittrich, dittrich@informatik.hu-berlin.de
Jon Kowal, kowal@informatik.hu-berlin.de

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
##############################################################################*/

#include "nip_types.h"

uint16_t nip_bswap16( uint16_t in )
{
	return (in>>8) + (in<<8);
}


uint32_t nip_bswap32( uint32_t in )
{
// 3 possibilies to test for 32-bit byte swap. #2 seems to be best.

	// #1
	/*	uint8_t  *ptr = (uint8_t*)&in;
	((uint16_t*)&ptr[1])[0] = nip_bswap16( (uint16_t)ptr[1] );
	((uint16_t*)ptr)[0] = nip_bswap16( (uint16_t)*ptr );
	((uint16_t*)ptr)[1] = nip_bswap16( (uint16_t)ptr[2] );
	return in;	*/

	// #2
	uint8_t *ptr = (uint8_t*)&in;
	uint8_t tmp;
	tmp    = ptr[1];
	ptr[1] = ptr[2];
	ptr[2] = tmp;
	tmp    = ptr[0];
	ptr[0] = ptr[3];
	ptr[3] = tmp;
	return in;

	// #3
// 	return (in&0xFF000000)>>24 + (in&0x00FF0000)>>8 + (in&0x0000FF00)<<8 + (in&0x000000FF)<<24;
}


