
#include <avr/io.h>
#include <avr/interrupt.h>

#include <dispatcher.h>

#include "init.h"
#include "arch/avr/rtl8019.h"
#include "net/net_if.h"

#include "net/tcp.h"
#include "app/ports.h"
#include "app/dns_sd.h"

#include "telnet.h"
#include "httpd.h"

int main( void )
{
	char x = 0;
#if (NIP_DNSSD_ENABLE == 1)
/*	nip_dnssd_id_t srv_id = NIP_DNSSD_NO_SERVICE;
	int  i = 0;
	uint8_t *instance_name = (uint8_t*)"\x03""avr";
	uint8_t *service_name  = (uint8_t*)"\x06""_nipev""\x04""_tcp";
	uint8_t *txt_records   = (uint8_t*)"\x08""you=suck";
	nip_mem_ptr_t  in_mem_ptr;
	nip_mem_ptr_t  srv_mem_ptr;
	nip_mem_ptr_t  txt_mem_ptr;*/
#endif

	sei();

	init_networking();
	init_time();

#if TELNET_ENABLE == 1
	telnet_start();
#endif
#if HTTPD_ENABLE == 1
	httpd_start();
#endif

//	Init_Realtek_Network_Card();

	DDRD =_BV( PD7 );


	while (1)
	{
#if TELNET_ENABLE == 1
		telnet_check();
#endif
#if HTTPD_ENABLE == 1
		httpd_check();
#endif

		if ( x++ % 2 == 0 )
			PORTD |= _BV( PD7 );
		else
			PORTD &= ~_BV( PD7 );

// 		for ( i=0; i<13000; i++);

#if (NIP_DNSSD_ENABLE == 1)

/*		if ( i == 0 )
		{
// Step here using the Debugger to register _nipev._tcp service
// after mDNS is up and running.

			in_mem_ptr.id  = NIP_MEM_NULL;
			in_mem_ptr.ptr = instance_name;
// 			instance_name[0] = 3;
			srv_mem_ptr.id  = NIP_MEM_NULL;
			srv_mem_ptr.ptr = service_name;
// 			service_name[0] = 7;
// 			service_name[8] = 4;
			txt_mem_ptr.id  = NIP_MEM_NULL;
			txt_mem_ptr.ptr = txt_records;
// 			txt_records[0]  = 8;
			srv_id = nip_dnssd_register( &in_mem_ptr, &srv_mem_ptr, &txt_mem_ptr,9, NIP_TCP_PORT_TELNET, 0, 0 );
		}
		*/
#endif

#if (NIP_DISP_ENABLE == 1)
		nip_disp_notify( NIP_DISP_TIMER );
		nip_disp_notify_if( 0, NIP_DISP_IF_TIMER );
		nip_dispatcher();

#endif
	}

	return 0;
}
